<?php
/*
  $Id: view_counter_install, v 1.0 2012/07/01 by Jack York

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce
  Portions Copyright 2012 oscommerce-solution.com

  Released under the GNU General Public License
*/

  require('includes/application_top.php');

  $db_error = false;

  $db_check_query = tep_db_query("SHOW TABLES LIKE 'view_counter%'");

  if (tep_db_num_rows($db_check_query) > 0) {
      echo 'Looks like View Counter is already installed. Aborting...';
      tep_exit();
  }


  $db_sql_array = array(

                  array("DROP TABLE IF EXISTS view_counter"),
                  array("DROP TABLE IF EXISTS view_counter_storage"),
                  array("DROP TABLE IF EXISTS view_counter_banned"),
                  array("DROP TABLE IF EXISTS view_counter_block_list"),
                  array("DROP TABLE IF EXISTS view_counter_blocked"),
                  array("DROP TABLE IF EXISTS view_counter_emails"),
                  array("DROP TABLE IF EXISTS view_counter_flags"),
                  array("DROP TABLE IF EXISTS view_counter_session_kill"),
                  array("DROP TABLE IF EXISTS view_counter_settings"),
                  array("DROP TABLE IF EXISTS view_counter_ignore"),

                  array("CREATE TABLE view_counter (ip_active tinyint (1) DEFAULT 1,isbot tinyint (1) DEFAULT 0,isadmin varchar (28) DEFAULT '',ip_number INT( 64 ) UNSIGNED NOT NULL,session_id varchar (128) DEFAULT '',file_name varchar (64) DEFAULT '',arg varchar (64) DEFAULT '',view_count int (11) DEFAULT 0,last_date datetime NOT NULL,bot_name VARCHAR (64) DEFAULT '', referrer VARCHAR (256) DEFAULT '', referrer_query VARCHAR (256) DEFAULT '', user_agent VARCHAR (128) DEFAULT '', language_id int DEFAULT '1' NOT NULL,index idx_file_name (file_name),index idx_ip_number (ip_number),index idx_language_id (language_id)) ENGINE=InnoDB"),
                  array("CREATE TABLE view_counter_storage (ip_active tinyint (1) DEFAULT 1,isbot tinyint (1) DEFAULT 0,isadmin varchar (28) DEFAULT '',ip_number INT( 64 ) UNSIGNED NOT NULL,session_id varchar (128) default '',file_name varchar (64) DEFAULT '',arg varchar (64) DEFAULT '',view_count int (11) DEFAULT 0,last_date datetime NOT NULL,bot_name VARCHAR (64) DEFAULT '', referrer VARCHAR (256) DEFAULT '', referrer_query VARCHAR (256) DEFAULT '', user_agent VARCHAR (128) DEFAULT '', language_id int DEFAULT '1' NOT NULL,index idx_file_name (file_name),index idx_ip_number (ip_number),index idx_language_id (language_id)) ENGINE=InnoDB"),
                  array("CREATE TABLE view_counter_banned (ip_number INT( 64 ) UNSIGNED NOT NULL, ip_string VARCHAR (64) NULL DEFAULT NULL, ignore_status tinyint (1) DEFAULT '0' NOT NULL, index idx_ip_number (ip_number), index idx_ip_string (ip_string)) ENGINE=InnoDB"),
                  array("CREATE TABLE view_counter_block_list (name_to_block VARCHAR (32) NOT NULL, index idx_name_to_block (name_to_block)) ENGINE=InnoDB"),
                  array("CREATE TABLE view_counter_blocked (ip_number INT( 64 ) UNSIGNED NOT NULL, country VARCHAR (32) NULL DEFAULT NULL, count int (11) DEFAULT '0' NOT NULL, index idx_ip_number (ip_number)) ENGINE=InnoDB"),
                  array("CREATE TABLE view_counter_emails (ip_number INT( 64 ) UNSIGNED NOT NULL, sent TINYINT ( 1 ) DEFAULT 0, index idx_ip_number (ip_number)) ENGINE=InnoDB"),
                  array("CREATE TABLE view_counter_flags (ip_number INT( 64 ) UNSIGNED NOT NULL, data blob DEFAULT '', index idx_ip_number (ip_number)) ENGINE=InnoDB"),
                  array("CREATE TABLE view_counter_session_kill (session_id varchar (128) DEFAULT '', session_msg text DEFAULT '') ENGINE=InnoDB"),
                  array("CREATE TABLE view_counter_settings (page_name varchar (32) DEFAULT '', sort_by varchar (64) DEFAULT '', sort_by_array tinyblob DEFAULT '', show_type varchar (64) DEFAULT '', show_type_array tinyblob DEFAULT '', sort_direction_array tinyblob DEFAULT '', view_active varchar (10) DEFAULT '', view_spoofed varchar (10) DEFAULT '', display_table varchar (10) DEFAULT '', colors mediumblob DEFAULT '', group_data mediumblob DEFAULT '') ENGINE=InnoDB"),
                  array("CREATE TABLE view_counter_ignore (ip_number INT( 64 ) UNSIGNED NOT NULL, UNIQUE KEY idx_ip_number (ip_number)) ENGINE=InnoDB"));


  // create tables
  foreach ($db_sql_array as $sql_array) {
    foreach ($sql_array as $value) {
      if (tep_db_query($value) == false) {
        $db_error = true;
      }
    }
  }

  $db_check_query = tep_db_query("select max(configuration_group_id) as id from configuration_group ");
  $max = tep_db_fetch_array($db_check_query);
  $configuration_group_id = $max['id'] + 1;

  // create configuration group
  $group_query = "INSERT INTO configuration_group (configuration_group_id, configuration_group_title, configuration_group_description, sort_order, visible ) VALUES ('" . $configuration_group_id . "', 'View Counter', 'View Counter site wide options', '122' , '1')";

  if (tep_db_query($group_query) == false) {
    $db_error = true;
  } else {
    $sortID = 1;

    // create configuration variables
    $fields = " configuration_id, configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added, use_function ";
    $db_sql_array = array(array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'ON/OFF', 'VIEW_COUNTER_ENABLED', 'false', 'View Counter <br>(true=on false=off)', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'API Key','VIEW_COUNTER_API_KEY', 'Your API KEY', 'Enter your IPInfoDB.com API Key here.<br><br>You can get your key at http://ipinfodb.com/register.php', '" . $configuration_group_id . "', '" . ($sortID++). "', NULL, now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Active Time','VIEW_COUNTER_ACTIVE_TIME', '10', 'The numbre of minutes to show active visitors.', '" . $configuration_group_id . "', '" . ($sortID++). "', NULL, now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Bad Bot Trap', 'VIEW_COUNTER_BAD_BOT_TRAP', 'Email', 'Choose how to handle the bad bot trap.<br><br><b>Ban:</b> Ban the IP<br><b>Email:</b> Send an Email containing the IP<br><b>Both:</b> Both of the above<br><b>Off:</b> Nothing will be done', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'Ban\', \'Email\', \'Both\', \'Off\'), ', now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Force Reset','VIEW_COUNTER_FORCE_RESET', '2', 'The maximum number of days to keep the IP\'s in the database. The View counter table will grow very large if not cleared and data over a few days is probably of no use.', '" . $configuration_group_id . "', '" . ($sortID++). "', NULL, now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Force Reset Storage','VIEW_COUNTER_FORCE_RESET_STORAGE', '14', 'The maximum number of days to keep the IP\'s in the storage table. This table is used for reports. It will grow very large if not cleared on a regular basis.', '" . $configuration_group_id . "', '" . ($sortID++). "', NULL, now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Hide Admin Links','VIEW_COUNTER_HIDE_ADMIN_LINKS', '', 'Do not show admin links for these IP\'s. Use a comma separted list for multiple IP\'s.', '" . $configuration_group_id . "', '" . ($sortID++). "', NULL, now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Kick Off', 'VIEW_COUNTER_ENABLE_KILL_SESSION', 'false', 'Enable the ability to kick off customes.', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Page Refresh Period','VIEW_COUNTER_PAGE_REFRESH', '120', 'How often, in seconds, to refresh the main page in admin.', '" . $configuration_group_id . "', '" . ($sortID++). "', NULL, now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Rows Per Page','VIEW_COUNTER_MAX_ROWS', '20', 'The maximum number of rows to display in the list.', '" . $configuration_group_id . "', '" . ($sortID++). "', NULL, now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Send Emails To','VIEW_COUNTER_SEND_EMAILS_TO', '', 'The email address any emails created by View Counter will be sent to. If left empty, the shops email address will be used.', '" . $configuration_group_id . "', '" . ($sortID++). "', NULL, now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Show Flags', 'VIEW_COUNTER_SHOW_FLAGS', 'true', 'Display the country flags. Turning this off will speed up the display. <br>(true=on false=off)', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Show Account Details', 'VIEW_COUNTER_SHOW_ACCOUNT_DETAILS', 'true', 'Display the account details of the visitor, if possible. If multiple accounts exist, they will all be shown. Enabling this option may cause a slow-down, depending upon the site. <br>(true=on false=off)', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"),
                          array("INSERT INTO configuration (" . $fields . ")  VALUES (NULL, 'Version Checker', 'VIEW_COUNTER_ENABLE_VERSION_CHECKER', 'false', 'Enable to automatically check if a new version is available. <br>(true=on false=off)', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"));



    foreach ($db_sql_array as $sql_array) {
      foreach ($sql_array as $value) {
        //echo $value . '<br>';
        if (tep_db_query($value) == false) {
          $db_error = true;
        }
      }
    }
  }

?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<base href="<?php echo (($request_type == 'SSL') ? HTTPS_SERVER : HTTP_SERVER) . DIR_WS_CATALOG; ?>">
<link rel="stylesheet" type="text/css" href="stylesheet.css">
</head>
<body>


<!-- body //-->
<table border="0" width="100%" cellspacing="3" cellpadding="3">
  <tr>

<!-- body_text //-->
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="pageHeading"><?php echo 'View Counter Database Installer'; ?></td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '100%', '10'); ?></td>
      </tr>
      <tr>
        <td class="main">
<?php
  if ($db_error == false) {
    echo 'Database successfully updated for View Counter!!!';
?>
        </td>
       </tr>
       <tr>
         <td><?php echo '<a href="' . tep_href_link(FILENAME_DEFAULT) . '">' . tep_image_button('button_continue.gif', IMAGE_BUTTON_CONTINUE) . '</a>'; ?></td>
       </tr>

<?php
  } else {
    echo 'Errors encountered during database update.</td></tr>';
  }
?>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '100%', '10'); ?></td>
      </tr>
    </table></td>
<!-- body_text_eof //-->

  </tr>
</table>
<!-- body_eof //-->

</body>
</html>

